=== debian/changelog ===
barrier (2.4.0+dfsg-4build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:33:24 +1100

barrier (2.4.0+dfsg-4build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 03:57:16 +0000

barrier (2.4.0+dfsg-4build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:27:19 +0000

barrier (2.4.0+dfsg-4) unstable; urgency=medium

  * d/p/add-missing-includes-for-gcc13.patch:
    - Grab an upstream PR to fix FTBFS with gcc-13. (Closes: #1037587)
  * Update Standards-Version to 4.6.2.

 -- Unit 193 <unit193@debian.org>  Fri, 14 Jul 2023 00:19:07 -0400

barrier (2.4.0+dfsg-3) unstable; urgency=medium

  * d/p/allow_gtest_exclusion.patch:
    - Allow exclusion of gtest if not building tests. (Closes: #1020987)

 -- Unit 193 <unit193@debian.org>  Fri, 14 Oct 2022 06:00:18 -0400

barrier (2.4.0+dfsg-2) unstable; urgency=medium

  * d/rules: Restrict tests to amd64 and i386 due to intermittent failures.

 -- Unit 193 <unit193@debian.org>  Fri, 10 Dec 2021 20:22:00 -0500

barrier (2.4.0+dfsg-1) unstable; urgency=medium

  * Happy 70th dad, may you rest in peace.
  * New upstream version 2.4.0+dfsg.
    - Drop patches.
    - Note this release uses multiple component tarballs to separate out a
      vendored header-only library, gulrak-filesystem.
  * d/control:
    - Build-Depend on libgmock-dev, xauth, xvfb and annotate tests <!nocheck>.
  * d/copyright: Update attribution.
  * d/p/include_gulrak.patch: Allow use of our bundled gulrak.
  * d/p/fix-includes.patch: Pull an upstream commit to fix FTBFS.
  * d/rules:
    - Pass the option to utilize system gtest.
    - Disable building tests if the nocheck option is used.
    - Run the tests manually as the make target is unable to find the binary.
    - Skip tests on s390x.
    - Drop --as-needed, as this is now default in stable.
  * d/watch: Bump to version 4.
  * Update Standards-Version to 4.6.0.

 -- Unit 193 <unit193@debian.org>  Wed, 10 Nov 2021 01:04:57 -0500
